=== modified file 'ChangeLog'
--- ChangeLog	2006-08-19 19:02:08 +0000
+++ ChangeLog	2006-08-19 20:31:46 +0000
@@ -1,5 +1,10 @@
 2006-08-19  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * olive/frontend/gtk/__init__.py: applied Diff toolbutton menu
+    * olive/frontend/gtk/menu.py: implemented the Diff toolbutton menu
+    * cmenu.ui: added Diff toolbutton menu; removed Log from right context menu
+    * olive.glade: swapped Diff and Log toolbuttons; coverted log button to an
+      ordinary GtkToolButton
     * olive/frontend/gtk/__init__.py: added win32 compatibility
     * olive/frontend/gtk/menu.py: added win32 compatibility
     * olive/frontend/gtk/branch.py: fixed a typo

=== modified file 'cmenu.ui'
--- cmenu.ui	2006-08-08 18:32:32 +0000
+++ cmenu.ui	2006-08-19 20:31:46 +0000
@@ -6,11 +6,14 @@
         <menuitem name="commit" action="commit" />
         <separator />
         <menuitem name="diff" action="diff" />
-        <menuitem name="log" action="log" />
         <separator />
         <menuitem name="bookmark" action="bookmark" />
     </popup>
     <popup name="context_left">
         <menuitem name="remove_bookmark" action="remove_bookmark" />
     </popup>
+    <popup name="toolbar_diff">
+        <menuitem name="diff_selected" action="diff_selected" />
+        <menuitem name="diff_all" action="diff_all" />
+    </popup>
 </ui>

=== modified file 'olive.glade'
--- olive.glade	2006-08-15 20:26:53 +0000
+++ olive.glade	2006-08-19 20:31:46 +0000
@@ -427,24 +427,6 @@
 	  </child>
 
 	  <child>
-	    <widget class="GtkMenuToolButton" id="menutoolbutton_log">
-	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">Log</property>
-	      <property name="use_underline">True</property>
-	      <property name="icon">log.png</property>
-	      <property name="visible_horizontal">True</property>
-	      <property name="visible_vertical">True</property>
-	      <property name="is_important">False</property>
-	      <signal name="show_menu" handler="on_menutoolbutton_log_show_menu" last_modification_time="Mon, 17 Jul 2006 09:04:28 GMT"/>
-	      <signal name="clicked" handler="on_menutoolbutton_log_clicked" last_modification_time="Mon, 17 Jul 2006 09:04:37 GMT"/>
-	    </widget>
-	    <packing>
-	      <property name="expand">False</property>
-	      <property name="homogeneous">False</property>
-	    </packing>
-	  </child>
-
-	  <child>
 	    <widget class="GtkMenuToolButton" id="menutoolbutton_diff">
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Diff</property>
@@ -453,7 +435,6 @@
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
-	      <signal name="show_menu" handler="on_menutoolbutton_diff_show_menu" last_modification_time="Mon, 17 Jul 2006 09:04:43 GMT"/>
 	      <signal name="clicked" handler="on_menutoolbutton_diff_clicked" last_modification_time="Mon, 17 Jul 2006 09:04:46 GMT"/>
 	    </widget>
 	    <packing>
@@ -463,6 +444,23 @@
 	  </child>
 
 	  <child>
+	    <widget class="GtkToolButton" id="toolbutton_log">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">Log</property>
+	      <property name="use_underline">True</property>
+	      <property name="icon">log.png</property>
+	      <property name="visible_horizontal">True</property>
+	      <property name="visible_vertical">True</property>
+	      <property name="is_important">False</property>
+	      <signal name="clicked" handler="on_toolbutton_log_clicked" last_modification_time="Sat, 19 Aug 2006 19:26:21 GMT"/>
+	    </widget>
+	    <packing>
+	      <property name="expand">False</property>
+	      <property name="homogeneous">True</property>
+	    </packing>
+	  </child>
+
+	  <child>
 	    <widget class="GtkSeparatorToolItem" id="separatortoolitem1">
 	      <property name="visible">True</property>
 	      <property name="draw">True</property>

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-08-19 19:02:08 +0000
+++ olive/frontend/gtk/__init__.py	2006-08-19 20:31:46 +0000
@@ -87,6 +87,8 @@
                 "on_menuitem_stats_log_activate": handler.on_menuitem_stats_log_activate,
                 "on_menuitem_stats_infos_activate": handler.on_menuitem_stats_infos_activate,
                 "on_toolbutton_refresh_clicked": handler.on_menuitem_view_refresh_activate,
+                "on_toolbutton_log_clicked": handler.on_menuitem_stats_log_activate,
+                "on_menutoolbutton_diff_clicked": handler.on_menuitem_stats_diff_activate,
                 "on_toolbutton_commit_clicked": handler.on_menuitem_branch_commit_activate,
                 "on_toolbutton_pull_clicked": handler.on_menuitem_branch_pull_activate,
                 "on_toolbutton_push_clicked": handler.on_menuitem_branch_push_activate,
@@ -109,6 +111,10 @@
         pos = self.pref.get_preference('paned_position', 'int')
         self.comm.hpaned_main.set_position(pos)
         
+        # Apply menu to the toolbutton
+        menubutton = self.toplevel.get_widget('menutoolbutton_diff')
+        menubutton.set_menu(handler.menu.toolbar_diff)
+        
         # Now we can show the window
         self.window.show_all()
         

=== modified file 'olive/frontend/gtk/menu.py'
--- olive/frontend/gtk/menu.py	2006-08-19 19:02:08 +0000
+++ olive/frontend/gtk/menu.py	2006-08-19 20:31:46 +0000
@@ -73,10 +73,6 @@
                                        'Diff', None,
                                        'Show the diff of the file',
                                        self.diff),
-                                      ('log', None,
-                                       'Log', None,
-                                       'Show the log of the file',
-                                       self.log),
                                       ('bookmark', None,
                                        'Bookmark', None,
                                        'Bookmark current location',
@@ -84,15 +80,23 @@
                                       ('remove_bookmark', gtk.STOCK_REMOVE,
                                        'Remove', None,
                                        'Remove the selected bookmark',
-                                       self.remove_bookmark)
+                                       self.remove_bookmark),
+                                      ('diff_selected', None,
+                                       'Selected...', None,
+                                       'Show the differences of the selected file',
+                                       self.diff_selected),
+                                      ('diff_all', None,
+                                       'All...', None,
+                                       'Show the differences of all files',
+                                       self.diff_all)
                                      ])
         
         self.ui.insert_action_group(self.actiongroup, 0)
         self.ui.add_ui_from_file(self.uifile)
         
         self.cmenu_right = self.ui.get_widget('/context_right')
-        
         self.cmenu_left = self.ui.get_widget('/context_left')
+        self.toolbar_diff = self.ui.get_widget('/toolbar_diff')
         
         # Set icons
         commit_menu = self.ui.get_widget('/context_right/commit')
@@ -107,12 +111,6 @@
         diff_icon = gtk.Image()
         diff_icon.set_from_pixbuf(diff_pixbuf)
         diff_menu.set_image(diff_icon)
-        log_menu = self.ui.get_widget('/context_right/log')
-        log_image = self.comm.menuitem_stats_log.get_image()
-        log_pixbuf = log_image.get_pixbuf()
-        log_icon = gtk.Image()
-        log_icon.set_from_pixbuf(log_pixbuf)
-        log_menu.set_image(log_icon)
 
     def right_context_menu(self):
         return self.cmenu_right
@@ -180,12 +178,6 @@
         diff = OliveDiff(self.gladefile, self.comm, self.dialog)
         diff.display()
     
-    def log(self, action):
-        """ Right context menu -> Log """
-        from log import OliveLog
-        log = OliveLog(self.gladefile, self.comm, self.dialog)
-        log.display()
-    
     def bookmark(self, action):
         """ Right context menu -> Bookmark """
         if self.comm.pref.add_bookmark(self.comm.get_path()):
@@ -202,3 +194,13 @@
         self.comm.pref.remove_bookmark(self.comm.get_selected_left())
         
         self.comm.refresh_left()
+    
+    def diff_selected(self, action):
+        """ Diff toolbutton -> Selected... """
+        print "DEBUG: not implemented."
+    
+    def diff_all(self, action):
+        """ Diff toolbutton -> All... """
+        from diff import OliveDiff
+        diff = OliveDiff(self.gladefile, self.comm, self.dialog)
+        diff.display()

